// This file is generated by kconfig_compiler_kf5 from kopetechatwindowsettings.kcfg.
// All changes you do to this file will be lost.
#ifndef KOPETECHATWINDOWSETTINGS_H
#define KOPETECHATWINDOWSETTINGS_H

#include <kopetechatwindow_shared_export.h>

#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

#include <kglobalsettings.h>
#include <kcolorscheme.h>
class KOPETECHATWINDOW_SHARED_EXPORT KopeteChatWindowSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:

    static KopeteChatWindowSettings *self();
    ~KopeteChatWindowSettings();

    /**
      Set Name of a Adium/Kopete chat window style.
    */
    static
    void setStyleName( const QString & v )
    {
      if (v != self()->mStyleName && !self()->isImmutable( QStringLiteral( "styleName" ) )) {
        self()->mStyleName = v;
        self()->mSettingsChanged |= signalStyleChanged;
      }
    }

    /**
      Get Name of a Adium/Kopete chat window style.
    */
    static
    QString styleName()
    {
      return self()->mStyleName;
    }

    /**
      Set Relative path to a CSS variant for the current style.
    */
    static
    void setStyleVariant( const QString & v )
    {
      if (!self()->isImmutable( QStringLiteral( "styleVariant" ) ))
        self()->mStyleVariant = v;
    }

    /**
      Get Relative path to a CSS variant for the current style.
    */
    static
    QString styleVariant()
    {
      return self()->mStyleVariant;
    }

    /**
      Set Group consecutive messages from the same user as one block.
    */
    static
    void setGroupConsecutiveMessages( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "groupConsecutiveMessages" ) ))
        self()->mGroupConsecutiveMessages = v;
    }

    /**
      Get Group consecutive messages from the same user as one block.
    */
    static
    bool groupConsecutiveMessages()
    {
      return self()->mGroupConsecutiveMessages;
    }

    /**
      Set Use a compact variant of the chat style for chatrooms.
    */
    static
    void setUseCompact( bool v )
    {
      if (!self()->isImmutable( QStringLiteral( "useCompact" ) ))
        self()->mUseCompact = v;
    }

    /**
      Get Use a compact variant of the chat style for chatrooms.
    */
    static
    bool useCompact()
    {
      return self()->mUseCompact;
    }

    /**
      Set Text color used when highlighting.
    */
    static
    void setHighlightForegroundColor( const QColor & v )
    {
      if (v != self()->mHighlightForegroundColor && !self()->isImmutable( QStringLiteral( "highlightForegroundColor" ) )) {
        self()->mHighlightForegroundColor = v;
        self()->mSettingsChanged |= signalChatwindowAppearanceChanged;
      }
    }

    /**
      Get Text color used when highlighting.
    */
    static
    QColor highlightForegroundColor()
    {
      return self()->mHighlightForegroundColor;
    }

    /**
      Set Background color used when highlighting.
    */
    static
    void setHighlightBackgroundColor( const QColor & v )
    {
      if (v != self()->mHighlightBackgroundColor && !self()->isImmutable( QStringLiteral( "highlightBackgroundColor" ) )) {
        self()->mHighlightBackgroundColor = v;
        self()->mSettingsChanged |= signalChatwindowAppearanceChanged;
      }
    }

    /**
      Get Background color used when highlighting.
    */
    static
    QColor highlightBackgroundColor()
    {
      return self()->mHighlightBackgroundColor;
    }

    /**
      Set Disable custom formatting set by users.
    */
    static
    void setChatFmtOverride( bool v )
    {
      if (v != self()->mChatFmtOverride && !self()->isImmutable( QStringLiteral( "chatFmtOverride" ) )) {
        self()->mChatFmtOverride = v;
        self()->mSettingsChanged |= signalMessageOverridesChanged;
      }
    }

    /**
      Get Disable custom formatting set by users.
    */
    static
    bool chatFmtOverride()
    {
      return self()->mChatFmtOverride;
    }

    /**
      Set Chat text color.
    */
    static
    void setChatTextColor( const QColor & v )
    {
      if (v != self()->mChatTextColor && !self()->isImmutable( QStringLiteral( "chatTextColor" ) )) {
        self()->mChatTextColor = v;
        self()->mSettingsChanged |= signalChatwindowAppearanceChanged;
      }
    }

    /**
      Get Chat text color.
    */
    static
    QColor chatTextColor()
    {
      return self()->mChatTextColor;
    }

    /**
      Set Chat background color.
    */
    static
    void setChatBackgroundColor( const QColor & v )
    {
      if (v != self()->mChatBackgroundColor && !self()->isImmutable( QStringLiteral( "chatBackgroundColor" ) )) {
        self()->mChatBackgroundColor = v;
        self()->mSettingsChanged |= signalChatwindowAppearanceChanged;
      }
    }

    /**
      Get Chat background color.
    */
    static
    QColor chatBackgroundColor()
    {
      return self()->mChatBackgroundColor;
    }

    /**
      Set Chat link color.
    */
    static
    void setChatLinkColor( const QColor & v )
    {
      if (v != self()->mChatLinkColor && !self()->isImmutable( QStringLiteral( "chatLinkColor" ) )) {
        self()->mChatLinkColor = v;
        self()->mSettingsChanged |= signalChatwindowAppearanceChanged;
      }
    }

    /**
      Get Chat link color.
    */
    static
    QColor chatLinkColor()
    {
      return self()->mChatLinkColor;
    }

    /**
      Set Chat font.
    */
    static
    void setChatFont( const QFont & v )
    {
      if (v != self()->mChatFont && !self()->isImmutable( QStringLiteral( "chatFont" ) )) {
        self()->mChatFont = v;
        self()->mSettingsChanged |= signalChatwindowAppearanceChanged;
      }
    }

    /**
      Get Chat font.
    */
    static
    QFont chatFont()
    {
      return self()->mChatFont;
    }


    enum {
      signalChatwindowAppearanceChanged = 0x1,
      signalMessageOverridesChanged = 0x2,
      signalStyleChanged = 0x4,
      signalStyleVariantChanged = 0x8
    };

  Q_SIGNALS:
    /**
      Emitted when the font and colors settings have changed.
    */
    void chatwindowAppearanceChanged();

    /**
      Emitted when the message overrides settings have changed.
    */
    void messageOverridesChanged();

    /**
      Emitted when the chat window style has changed.
    */
    void styleChanged(const QString & styleName);

    /**
      Emitted when ChatWindowStyle variant has changed.
    */
    void styleVariantChanged(const QString & styleVariant);

  private:
    void itemChanged(quint64 flags);

  protected:
    KopeteChatWindowSettings();
    friend class KopeteChatWindowSettingsHelper;

    bool usrSave() override;

    // Appearance
    QString mStyleName;
    QString mStyleVariant;
    bool mGroupConsecutiveMessages;
    bool mUseCompact;
    QColor mHighlightForegroundColor;
    QColor mHighlightBackgroundColor;
    bool mChatFmtOverride;
    QColor mChatTextColor;
    QColor mChatBackgroundColor;
    QColor mChatLinkColor;
    QFont mChatFont;

  private:
    uint mSettingsChanged;
};

#endif

